Sql Server Instances - pre Upgrade

Request Upgrade Permission before upgrading.

POST https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.AzureArcData/sqlServerInstances/{sqlServerInstanceName}/preUpgrade?api-version=2026-01-01

URI Parameters

Name In Required Type Description
resourceGroupName
path True

string

The name of the Azure resource group

sqlServerInstanceName
path True

string

Name of SQL Server Instance

subscriptionId
path True

string

The ID of the Azure subscription

api-version
query True

string

minLength: 1

The API version to use for this operation.

Responses

Name Type Description
200 OK

SqlServerInstance

Successfully requested upgrade permission for the instance.

Other Status Codes

ErrorResponse

*** Error Responses: ***

Examples

Prepare SQL server instance for AUM Upgrade.

Sample request

POST https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/testrg/providers/Microsoft.AzureArcData/sqlServerInstances/testsqlServerInstance/preUpgrade?api-version=2026-01-01

Sample response

{
  "properties": {
    "version": "SQL Server 2012",
    "edition": "Developer",
    "containerResourceId": "Resource id of hosting Arc Machine",
    "vmId": "12345678-1234-1234-1234-123456789123",
    "createTime": "01/01/2020 01:01:01",
    "patchLevel": "patchlevel",
    "collation": "collation",
    "isMicrosoftPkiCertTrustConfigured": true,
    "isDigiCertPkiCertTrustConfigured": true,
    "dbMasterKeyExists": true,
    "isHadrEnabled": true,
    "traceFlags": [
      1800,
      9567
    ],
    "currentVersion": "2012",
    "instanceName": "name of instance",
    "tcpDynamicPorts": "1433",
    "tcpStaticPorts": "1433",
    "productId": "sql id",
    "vCore": "4",
    "cores": "4",
    "licenseType": "Free",
    "azureDefenderStatusLastUpdated": "2020-01-02T17:18:19.1234567Z",
    "azureDefenderStatus": "Protected",
    "status": "Registered",
    "hostType": "Physical Server",
    "lastInventoryUploadTime": "2023-03-29T14:13:12Z",
    "alwaysOnRole": "FailoverClusterInstance",
    "failoverCluster": {
      "id": "f836af7e-85ed-4ea4-91fb-67709b34e323",
      "networkName": "networkNameOfSQLFCI",
      "sqlInstanceIds": [
        "/subscriptions/dummySub/resourceGroups/dummyRG/providers/Microsoft.AzureArcData/SqlServerInstances/sqlServer1",
        "/subscriptions/dummySub/resourceGroups/dummyRG/providers/Microsoft.AzureArcData/SqlServerInstances/sqlServer2"
      ],
      "hostNames": [
        "DEV-HOSTNAME1",
        "DEV-HOSTNAME2"
      ],
      "hostIPAddresses": [
        {
          "ipAddress": "10.20.11.23",
          "subnetMask": "255.255.255.0"
        },
        {
          "ipAddress": "10.20.11.24",
          "subnetMask": "255.255.255.0"
        }
      ]
    },
    "backupPolicy": {
      "retentionPeriodDays": 1,
      "fullBackupDays": 1,
      "differentialBackupHours": 12,
      "transactionLogBackupMinutes": 30
    },
    "upgradeLockedUntil": "2022-05-05T16:26:33.883Z",
    "serviceType": "Engine",
    "maxServerMemoryMB": 4096
  },
  "location": "northeurope",
  "systemData": {
    "createdBy": "user1",
    "createdByType": "User",
    "createdAt": "2020-01-01T17:18:19.1234567Z",
    "lastModifiedBy": "user2",
    "lastModifiedByType": "User",
    "lastModifiedAt": "2020-01-02T17:18:19.1234567Z"
  },
  "tags": {
    "mytag": "myval"
  },
  "id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/testrg/providers/Microsoft.AzureArcData/SqlServerInstances/testsqlServerInstance",
  "name": "testsqlServerInstance",
  "type": "Microsoft.AzureArcData/SqlServerInstances"
}

Definitions

Name Description
alwaysOnRole

The role of the SQL Server, based on availability.

arcSqlServerLicenseType

SQL Server license type.

Authentication

Authentication related configuration for the SQL Server Instance.

BackupPolicy

The backup profile for the SQL server.

BestPracticesAssessment

The configuration related to SQL best practices assessment.

Category
ClientConnection

Client connection related configuration.

connectionAuth

Permitted authentication modes for the mirroring endpoint.

ConnectionStatus

The cloud connectivity status.

CostOptionSelectedValues

Selected cost option value.

CostTypeValues

The Monthly cost of the particular SKU.

createdByType

The type of identity that created the resource.

CronTrigger

The cron trigger configuration.

DBMEndpoint

Database mirroring endpoint related properties.

defenderStatus

Status of Azure Defender.

differentialBackupHours

The differential backup interval in hours.

DiskSizes

Data disk sizes.

editionType

SQL Server edition.

encryptionAlgorithm

Encryption Algorithm

EntraAuthentication

Entra Authentication configuration for the SQL Server Instance.

ErrorAdditionalInfo

The resource management error additional info.

ErrorDetail

The error detail.

ErrorResponse

Error response

FailoverCluster

Failover Cluster Instance properties.

hostIPAddressInformation

The IP addresses and subnet masks associated with the SQL Failover Cluster Instance on this host.

hostType

Type of host for Azure Arc SQL Server

identityType

The method used for Entra authentication

ImpactedObjects
ImpactedObjectsInfo
ImpactedObjectsSuitabilitySummary

Represents a summary of migration readiness issues/warnings per feature type for Azure SQL DB and SQL MI targets

Migration

Migration related configuration.

MigrationAssessment

Migration assessments related configuration.

MigrationAssessmentSettings

Settings impacting the migration assessment computation - configurable with some default values if not set.

mode

Mode of authentication in SqlServer.

Monitoring

The monitoring configuration.

recommendationStatus

The target recommendation Status for this database.

role

Mirroring Role

Schedule

The scheduling configuration.

ServerAssessments

Issues and warnings impacting the migration of SQL Server instance to particular Azure Migration Target.

serviceType

Indicates if the resource represents a SQL Server engine or a SQL Server component service installed on the host.

SkuRecommendationResults

SKU Recommendation results for Azure migration targets for SQL Server.

SkuRecommendationResultsAzureSqlDatabase

SKU Recommendation results for Azure SQL Database.

SkuRecommendationResultsAzureSqlManagedInstance

SKU Recommendation results for Azure SQL Managed Instance.

SkuRecommendationResultsAzureSqlVirtualMachine

SKU Recommendation results for Azure SQL Virtual Machine.

SkuRecommendationResultsMonthlyCost

The monthly cost of the particular SKU.

SkuRecommendationResultsMonthlyCostOptionItem

The monthly cost for all different savings options applicable for the particular SKU.

SqlServerInstance

A SqlServerInstance.

SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlManagedInstance.TargetSku
SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlManagedInstance.targetSku.Category
SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlVirtualMachine.TargetSku
SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlVirtualMachine.targetSku.Category
SqlServerInstanceProperties

null

sqlVersion

SQL Server version.

systemData

Metadata pertaining to creation and last modification of the resource.

TargetSku
VirtualMachineSize

size parameters for VM size.

alwaysOnRole

The role of the SQL Server, based on availability.

Value Description
None
FailoverClusterInstance
FailoverClusterNode
AvailabilityGroupReplica

arcSqlServerLicenseType

SQL Server license type.

Value Description
Undefined
Free
HADR
ServerCAL
LicenseOnly
PAYG
Paid
FabricCapacity

Authentication

Authentication related configuration for the SQL Server Instance.

Name Type Description
mode

mode

Mode of authentication in SqlServer.

sqlServerEntraIdentity

EntraAuthentication[]

Entra Authentication configuration for the SQL Server Instance.

BackupPolicy

The backup profile for the SQL server.

Name Type Description
differentialBackupHours

differentialBackupHours (int32)

The differential backup interval in hours.

fullBackupDays

integer (int32)

minimum: 0
maximum: 7

The value indicating days between full backups.

retentionPeriodDays

integer (int32)

minimum: 0
maximum: 35

The retention period for all the databases in this managed instance.

transactionLogBackupMinutes

integer (int32)

minimum: 0
maximum: 60

The value indicating minutes between transaction log backups.

BestPracticesAssessment

The configuration related to SQL best practices assessment.

Name Type Description
enabled

boolean

Indicates if SQL best practices assessment is enabled for the SQL Server instance.

schedule

Schedule

The scheduling configuration.

Category

Name Type Description
computeTier

string

The compute tier of the target SKU.

hardwareType

string

The hardware type of the target SKU.

sqlPurchasingModel

string

The SQL purchasing model of the target SKU.

sqlServiceTier

string

The SQL service tier of the target SKU.

zoneRedundancyAvailable

boolean

Indicates if zone redundancy is available for the target SKU.

ClientConnection

Client connection related configuration.

Name Type Description
enabled

boolean

Indicates if client connection is enabled for this SQL Server instance.

connectionAuth

Permitted authentication modes for the mirroring endpoint.

Value Description
Windows_NTLM
Windows_Kerberos
Windows_Negotiate
Certificate
Windows_NTLM_Certificate
Windows_Kerberos_Certificate
Windows_Negotiate_Certificate
Certificate_Windows_NTLM
Certificate_Windows_Kerberos
Certificate_Windows_Negotiate

ConnectionStatus

The cloud connectivity status.

Value Description
Connected
Disconnected
Registered
Unknown

CostOptionSelectedValues

Selected cost option value.

Name Type Description
computeAndStorageCostOption

string

selected cost saving option e.g. With1YearASPAndDevTest.

sqlLicenseCostOption

string

With Azure Hybrid Benefit(AHB) or not for SQL.

windowsLicenseCostOption

string

With Azure Hybrid Benefit(AHB) or not for Windows.

CostTypeValues

The Monthly cost of the particular SKU.

Name Type Description
computeCost

number (float)

Represents the Cost of Compute.

iopsCost

number (float)

Represents the Cost of IOPS.

storageCost

number (float)

Represents the Cost of Storage.

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

CronTrigger

The cron trigger configuration.

Name Type Description
expression

string

A cron string representing a CronTab expression. A crontab expression is a very compact way to express a recurring schedule with the following format: '{minutes} {hours} {days} {months} {days-of-week}'.

startTime

string

Indicates the start time for the trigger. The default value is the time at which the trigger was created.

timeZone

string

The time zone in which the trigger is scheduled.

DBMEndpoint

Database mirroring endpoint related properties.

Name Type Description
certificateExpiryDate

string (date-time)

The certificate expiry date

certificateName

string

Name of the certificate.

connectionAuth

connectionAuth

The type of connection authentication required for connections to this endpoint

encryptionAlgorithm

encryptionAlgorithm

Encryption Algorithm

endpointName

string

Name of the database mirroring endpoint.

ipAddress

string

Listener IP address.

isDynamicPort

boolean

Is the port number dynamically assigned.

isEncryptionEnabled

boolean

Is Encryption enabled

port

integer (int32)

The port number that the endpoint is listening on.

role

role

Mirroring Role

defenderStatus

Status of Azure Defender.

Value Description
Protected
Unprotected
Unknown

differentialBackupHours

The differential backup interval in hours.

Value Description
12
24

DiskSizes

Data disk sizes.

Name Type Description
caching

string

Caching configuration - e.g. read only caching

diskType

string

Type of managed disk.

maxIops

number (float)

maximum number of input/output operations per second (IOPS).

maxSizeInGib

number (float)

maximum disk size in GiB.

maxThroughputInMbps

number (float)

maximum throughput in MB/s.

redundancy

string

Redundancy option.

size

string

Size of the managed disk - e.g. P30, P40.

editionType

SQL Server edition.

Value Description
Evaluation
Enterprise
Standard
Web
Developer
Express
Business Intelligence
Standard Developer

encryptionAlgorithm

Encryption Algorithm

Value Description
NONE
RC4
AES
NONE, RC4
NONE, AES
RC4, AES
AES, RC4
NONE, RC4, AES
NONE, AES, RC4

EntraAuthentication

Entra Authentication configuration for the SQL Server Instance.

Name Type Description
clientId

string

The client Id of the Managed Identity to query Microsoft Graph API. An empty string must be used for the system assigned Managed Identity.

identityType

identityType

The method used for Entra authentication

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

object

The additional info.

type

string

The additional info type.

ErrorDetail

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

ErrorDetail[]

The error details.

message

string

The error message.

target

string

The error target.

ErrorResponse

Error response

Name Type Description
error

ErrorDetail

The error object.

FailoverCluster

Failover Cluster Instance properties.

Name Type Description
hostIPAddresses

hostIPAddressInformation[]

The IP addresses and subnet masks associated with the SQL Failover Cluster Instance on this host.

hostNames

string[]

The host names which are part of the SQL FCI resource group.

id

string

The GUID of the SQL Server's underlying Failover Cluster.

networkName

string

The network name to connect to the SQL FCI.

sqlInstanceIds

string[]

The ARM IDs of the Arc SQL Server resources, belonging to the current server's Failover cluster.

hostIPAddressInformation

The IP addresses and subnet masks associated with the SQL Failover Cluster Instance on this host.

Name Type Description
ipAddress

string

IP address

subnetMask

string

Subnet mask

hostType

Type of host for Azure Arc SQL Server

Value Description
Azure Virtual Machine
Azure VMWare Virtual Machine
Azure Kubernetes Service
AWS VMWare Virtual Machine
AWS Kubernetes Service
GCP VMWare Virtual Machine
GCP Kubernetes Service
Container
Virtual Machine
Physical Server
AWS Virtual Machine
GCP Virtual Machine
Other

identityType

The method used for Entra authentication

Value Description
SystemAssignedManagedIdentity

System Assigned Managed Identity

UserAssignedManagedIdentity

User Assigned Managed Identity

ImpactedObjects

Name Type Description
impactDetail

string

name

string

objectType

string

ImpactedObjectsInfo

Name Type Description
featureId

string

Represents the feature id from https://learn.microsoft.com/en-us/data-migration/sql-server/database/assessment-rules?view=azuresql. OR https://learn.microsoft.com/en-us/data-migration/sql-server/managed-instance/assessment-rules?view=azuresql

issueCategory

string

Issue or Warning

numberImpacted

number (int32)

Represents the number of issues/warnings.

ImpactedObjectsSuitabilitySummary

Represents a summary of migration readiness issues/warnings per feature type for Azure SQL DB and SQL MI targets

Name Type Description
azureSqlDatabase

ImpactedObjectsInfo[]

summary information about the incompatible feature id, number of objects impacted and category of issue (warning/error)

azureSqlManagedInstance

ImpactedObjectsInfo[]

summary information about the incompatible feature id, number of objects impacted and category of issue (warning/error)

Migration

Migration related configuration.

Name Type Description
assessment

MigrationAssessment

Migration assessments related configuration.

MigrationAssessment

Migration assessments related configuration.

Name Type Description
assessmentUploadTime

string (date-time)

The time when Migration Assessment Report upload was last performed.

enabled

boolean

Indicates if migration assessment is enabled for this SQL Server instance.

impactedObjectsSummary

ImpactedObjectsSuitabilitySummary

Represents a summary of migration readiness issues/warnings per feature type for Azure SQL DB and SQL MI targets

serverAssessments

ServerAssessments[]

Issues and warnings impacting the migration of SQL Server instance to particular Azure Migration Target.

settings

MigrationAssessmentSettings

Settings impacting the migration assessment computation - configurable with some default values if not set.

skuRecommendationResults

SkuRecommendationResults

SKU Recommendation results for Azure migration targets for SQL Server.

version

string

version of this migration assessment report - to be passed by the migration assessment engine.

MigrationAssessmentSettings

Settings impacting the migration assessment computation - configurable with some default values if not set.

Name Type Description
costOptions

CostOptionSelectedValues

Selected cost option value.

currency

string

currency to calculate prices - default USD.

discountPercentage

number (float)

flat discount percentage to apply for the price - default 0

lookbackPeriodInDays

number (int32)

How far back to check the performance data - default is 30 (days).

percentile

number (float)

Indicate the percentile value for the performance sample. (Default is 95th percentile)

strategy

string

Minimize cost or Migrate to PaaS. - to evaluate based on the recommended strategy

targetLocation

string

The target location for Azure SQL SKU for migration. - default West US

mode

Mode of authentication in SqlServer.

Value Description
Mixed

Mixed mode authentication for SQL Server which includes windows and SQL Authentication.

Windows

Windows Authentication for SQL Server.

Undefined

Used for scenarios were the mode cannot be determined.

Monitoring

The monitoring configuration.

Name Type Description
enabled

boolean

Indicates if monitoring is enabled for this SQL Server instance.

recommendationStatus

The target recommendation Status for this database.

Value Description
NotReady
Ready
ReadyWithConditions
Unknown

role

Mirroring Role

Value Description
NONE
PARTNER
WITNESS
ALL

Schedule

The scheduling configuration.

Name Type Description
cronTrigger

CronTrigger

The cron trigger configuration.

enabled

boolean

Indicates whether scheduling is enabled.

ServerAssessments

Issues and warnings impacting the migration of SQL Server instance to particular Azure Migration Target.

Name Type Description
appliesToMigrationTargetPlatform

string

featureId

string

impactedObjects

ImpactedObjects[]

issueCategory

string

moreInformation

string

serviceType

Indicates if the resource represents a SQL Server engine or a SQL Server component service installed on the host.

Value Description
Engine

SQL Server Database Services.

SSRS

SQL Server Reporting Services.

SSAS

SQL Server Analysis Services.

SSIS

SQL Server Integration Services.

PBIRS

Power BI Report Server.

SkuRecommendationResults

SKU Recommendation results for Azure migration targets for SQL Server.

Name Type Description
azureSqlDatabase

SkuRecommendationResultsAzureSqlDatabase

SKU Recommendation results for Azure SQL Database.

azureSqlManagedInstance

SkuRecommendationResultsAzureSqlManagedInstance

SKU Recommendation results for Azure SQL Managed Instance.

azureSqlVirtualMachine

SkuRecommendationResultsAzureSqlVirtualMachine

SKU Recommendation results for Azure SQL Virtual Machine.

SkuRecommendationResultsAzureSqlDatabase

SKU Recommendation results for Azure SQL Database.

Name Type Description
monthlyCost

SkuRecommendationResultsMonthlyCost

The monthly cost of the particular SKU.

monthlyCostOptions

SkuRecommendationResultsMonthlyCostOptionItem[]

The monthly cost for all different savings options applicable for the particular SKU.

numberOfServerBlockerIssues

integer (int32)

Number of blocker issues to fix before migrating to the target platform.

recommendationStatus

recommendationStatus

The target recommendation Status for this database.

targetSku

TargetSku

SkuRecommendationResultsAzureSqlManagedInstance

SKU Recommendation results for Azure SQL Managed Instance.

Name Type Description
monthlyCost

SkuRecommendationResultsMonthlyCost

The monthly cost of the particular SKU.

monthlyCostOptions

SkuRecommendationResultsMonthlyCostOptionItem[]

The monthly cost for all different savings options applicable for the particular SKU.

numberOfServerBlockerIssues

integer (int32)

Number of blocker issues to fix before migrating to the target platform.

recommendationStatus

recommendationStatus

The target recommendation Status for this database.

targetSku

SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlManagedInstance.TargetSku

SkuRecommendationResultsAzureSqlVirtualMachine

SKU Recommendation results for Azure SQL Virtual Machine.

Name Type Description
monthlyCost

SkuRecommendationResultsMonthlyCost

The monthly cost of the particular SKU.

monthlyCostOptions

SkuRecommendationResultsMonthlyCostOptionItem[]

The monthly cost for all different savings options applicable for the particular SKU.

numberOfServerBlockerIssues

integer (int32)

Number of blocker issues to fix before migrating to the target platform.

recommendationStatus

recommendationStatus

The target recommendation Status for this database.

targetSku

SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlVirtualMachine.TargetSku

SkuRecommendationResultsMonthlyCost

The monthly cost of the particular SKU.

Name Type Description
computeCost

number (float)

Represents the Cost of Compute.

iopsCost

number (float)

Represents the Cost of IOPS.

sqlLicenseCost

number (float)

Represents the Cost of SQL license.

storageCost

number (float)

Represents the Cost of Storage.

totalCost

number (float)

Represents the Total Cost.

windowsLicenseCost

number (float)

Represents the Cost of Windows license.

SkuRecommendationResultsMonthlyCostOptionItem

The monthly cost for all different savings options applicable for the particular SKU.

Name Type Description
keyName

string

The unique combination of saving options for a price e.g. With1YearASPAndProd.

keyValue

CostTypeValues

The Monthly cost of the particular SKU.

SqlServerInstance

A SqlServerInstance.

Name Type Description
id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

location

string

The geo-location where the resource lives

name

string

The name of the resource

properties

SqlServerInstanceProperties

null

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

tags

object

Resource tags.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlManagedInstance.TargetSku

Name Type Description
category

SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlManagedInstance.targetSku.Category

computeSize

number (int32)

Compute Size in vCores.

maxStorageIops

number (float)

The maximum storage IOPS in Azure SQL, will impact the billing cost.

maxThroughputMBps

number (float)

The maximum throughput in Azure SQL, will impact the billing cost.

predictedDataSizeInMb

number (float)

The predicted data size in MB in Azure SQL, will impact the billing cost.

predictedLogSizeInMb

number (float)

The predicted log size in MB in Azure SQL, will impact the billing cost.

storageMaxSizeInMb

number (float)

maximum storage for this particular SKU, in MB.

SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlManagedInstance.targetSku.Category

Name Type Description
computeTier

string

The compute tier of the target SKU.

hardwareType

string

The hardware type of the target SKU.

sqlPurchasingModel

string

The SQL purchasing model of the target SKU.

sqlServiceTier

string

The SQL service tier of the target SKU.

zoneRedundancyAvailable

boolean

Indicates if zone redundancy is available for the target SKU.

SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlVirtualMachine.TargetSku

Name Type Description
category

SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlVirtualMachine.targetSku.Category

computeSize

number (int32)

Compute Size in vCores.

dataDiskSizes

DiskSizes[]

Data disk sizes.

logDiskSizes

DiskSizes[]

Log disk sizes.

predictedDataSizeInMb

number (float)

The predicted data size in MB in Azure SQL, will impact the billing cost.

predictedLogSizeInMb

number (float)

The predicted log size in MB in Azure SQL, will impact the billing cost.

tempDbDiskSizes

DiskSizes[]

temp db disk sizes.

virtualMachineSize

VirtualMachineSize

size parameters for VM size.

SqlServerInstance.SqlServerInstanceProperties.Migration.MigrationAssessment.SkuRecommendationResults.SkuRecommendationResultsAzureSqlVirtualMachine.targetSku.Category

Name Type Description
availableVmSkus

string[]

Available VM SKUs for the Azure SQL Virtual Machine.

virtualMachineFamily

string

The virtual machine family of the target SKU.

SqlServerInstanceProperties

null

Name Type Description
alwaysOnRole

alwaysOnRole

The role of the SQL Server, based on availability.

authentication

Authentication

Authentication related configuration for the SQL Server Instance.

azureDefenderStatus

defenderStatus

Status of Azure Defender.

azureDefenderStatusLastUpdated

string (date-time)

Timestamp of last Azure Defender status update.

backupPolicy

BackupPolicy

The backup profile for the SQL server.

bestPracticesAssessment

BestPracticesAssessment

The configuration related to SQL best practices assessment.

clientConnection

ClientConnection

Client connection related configuration.

collation

string

SQL Server collation.

containerResourceId

string

ARM Resource id of the container resource (Azure Arc for Servers).

cores

string

The number of total cores of the Operating System Environment (OSE) hosting the SQL Server instance.

createTime

string

The time when the resource was created.

currentVersion

string

SQL Server current version.

databaseMirroringEndpoint

DBMEndpoint

Database mirroring endpoint related properties.

dbMasterKeyExists

boolean

Indicates whether database master key exists in SQL Server.

edition

editionType

SQL Server edition.

failoverCluster

FailoverCluster

Failover Cluster Instance properties.

hostType

hostType

Type of host for Azure Arc SQL Server

instanceName

string

SQL Server instance name.

isDigiCertPkiCertTrustConfigured

boolean

Indicates whether DigiCert PKI root-authority certificate (trusted by Azure) exists in SQL Server and trusted for Azure database.windows.net domains.

isHadrEnabled

boolean

Indicates whether always On availability groups is enabled in SQL Server.

isMicrosoftPkiCertTrustConfigured

boolean

Indicates whether Microsoft PKI root-authority certificate (trusted by Azure) exists in SQL Server and trusted for Azure database.windows.net domains.

lastInventoryUploadTime

string (date-time)

The time when last successful inventory upload was performed.

lastUsageUploadTime

string (date-time)

The time when last successful usage upload was performed.

licenseType

arcSqlServerLicenseType

SQL Server license type.

maxServerMemoryMB

integer (int64)

maximum server memory (MB) value configured for this instance.

migration

Migration

Migration related configuration.

monitoring

Monitoring

The monitoring configuration.

patchLevel

string

SQL Server update level.

productId

string

SQL Server product ID.

provisioningState

string

The provisioning state of the Arc-enabled SQL Server resource.

serviceType

serviceType

Indicates if the resource represents a SQL Server engine or a SQL Server component service installed on the host.

status

ConnectionStatus

The cloud connectivity status.

tcpDynamicPorts

string

Dynamic TCP ports used by SQL Server.

tcpStaticPorts

string

Static TCP ports used by SQL Server.

traceFlags

integer[] (int32)

An array of integers, where each value represents the enabled trace flags in SQL Server.

upgradeLockedUntil

string (date-time)

Upgrade Action for this resource is locked until it expires. The Expiration time indicated by this value. It is not locked when it is empty.

vCore

string

The number of logical processors used by the SQL Server instance.

version

sqlVersion

SQL Server version.

vmId

string

The unique ID of the hybrid machine that this resource belongs to.

sqlVersion

SQL Server version.

Value Description
Unknown
SQL Server 2012
SQL Server 2014
SQL Server 2016
SQL Server 2017
SQL Server 2019
SQL Server 2022
SQL Server 2025

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.

TargetSku

Name Type Description
category

Category

computeSize

number (int32)

Compute Size in vCores.

maxStorageIops

number (float)

The maximum storage IOPS in Azure SQL, will impact the billing cost.

maxThroughputMBps

number (float)

The maximum throughput in Azure SQL, will impact the billing cost.

predictedDataSizeInMb

number (float)

The predicted data size in MB in Azure SQL, will impact the billing cost.

predictedLogSizeInMb

number (float)

The predicted log size in MB in Azure SQL, will impact the billing cost.

storageMaxSizeInMb

number (float)

maximum storage for this particular SKU, in MB.

VirtualMachineSize

size parameters for VM size.

Name Type Description
azureSkuName

string

Virtual Machine SKU name,: Eg : Standard_F16s.

computeSize

number (int32)

Compute Size in vCores.

maxNetworkInterfaces

number (int32)

maximum network interfaces.

sizeName

string

VM Size, for example : M64ls

vCPUsAvailable

number (int32)

Available vCores. This can be less than the vCores in the Constrained vCPU VM Sizes.

virtualMachineFamily

string

Virtual Machine Family, for example : standardMSFamily